////////////////////////////////////////////////////////////////////////////////////
// PROYECTO FIN DE CARRERA															  											 	//
// TITULO: Disenyo de nuevas arquitecturas y algoritmos de gesti�n de recursos en	//
//		  	 redes de acceso FiWi  												  												//
// AUTOR: Ana Emma Lopez Mato																											//
// TUTOR: Noemi Merayo Alvarez																										//
// INGENIERIA TECNICA DE TELECOMUNICACIONES, SISTEMAS DE TELECOMUNICACION					//
// UNIVERSIDAD DE VALLADOLID													      											//
////////////////////////////////////////////////////////////////////////////////////

#include "OLT_Table.h"
#include <vector>
#include "GATE_m.h"
#include "REPORT_m.h"
#include "ETHERNET_m.h"
/*
 * MODULO OLT_Table:
 */
Define_Module(OLT_Table);

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION NUMINITSTAGES()--> ESTA FUNCION INICIALIZA VARIAS ETAPAS. SE DEFINE PARA QUE DEVUELVA EL NUMERO DE ETAPAS DE INICIO.  //
//							 EN NUESTRO CASO, LA FUNCION DEVUELVE EL VALOR 1 YA QUE SOLO TENEMOS UNA ETAPA DE INICIALIZACION.	//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int OLT_Table::numInitStages() const{return 1;}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION INITIALIZE()--> ESTA FUNCION SE INVOCA DESPUES DE QUE OMNET++ HA PUESTO EN MARCHA LA RED, EN LA CUAL SE LEEN LOS      //
//						  PARAMETROS DEL MODULO Y SE INICIALIZAN TODAS DAS LAS VARIABLES DECLARADAS PARA ESTE MODULO SIMPLE, SE //
//						  ASIGNAN ESTRUCTURAS DE DATOS DINAMICOS Y SE ASIGNAN E INICIALIZAN LOS AUTOMENSAJES SI SON NECESARIOS  //
//						  PARA EL FUNCIONAMIENTO DE ESTE MODULO.			   													//
//						  LA FUNCION INITIALIZE(INT STAGE) SE UTILIZA PARA INICIALIZAR VARIAS ETAPAS SEGUN EL VALOR STAGE.      //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void OLT_Table::initialize(int stage)
{
	// VARIABLES
	int file = (int)par("numOnu"); // VARIABLE QUE INDICA EL NUMERO DE FILAS DE LA TABLA DEL MODULO OLT_TABLE
	int columns = (int)par("numqueue")+2; // VARIABLE QUE INDICA EL NUMERO DE COLUMNAS DE LA TABLA DEL MODULO OLT_TABLE

	if(stage==0)
	{
		// RESERVAMOS DE FORMA DINAMICA EL TAMANYO DE LA TABLA E INICIALIZAMOS A 0
		// DEFINIMOS LAS VARIABLES QUE NOS MARCAN EL TRAMANYO DE LA MATRIZ
		table_olt_report_time.resize(1,0);
		table_olt_wavelength_time.resize(file,0);


		table_olt_report.resize(file);
		// CREAMOS LA MATRIZ MEDIANTE EL BUCLE FOR
		for(int m=0;m<file;m++)
		{
			table_olt_report[m].resize(columns,0);
		}
	}
	
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FUNCION HANDLEMESSAGE(CMESSAGE *MSG)--> ESTA FUNCION SE INVOCA CON EL MENSAJE COMO PARAMETRO CADA VEZ QUE EL MODULO RECIBE UN //
//										  UN MENSAJE O PAQUETE. SE RECORRE EL CODIGO IMPLEMENTADO PARA DEVOLVER UN VALOR O  	//
//										  EJECUTAR UNA FUNCION DENTRO DEL MODULO SIMPLE. EL TIEMPO DE SIMULACION NO TRANSCURRE  //
//										  DENTRO DE LA LLAMADA DE LA FUNCION HANDLEMESSAGE(CMESSAGE *MSG) MIENTRAS RECORRE EL	//
//										  CODIGO IMPLEMENTADO.																	//                                                                         //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void OLT_Table::handleMessage(cMessage *msg)
{
}
