////////////////////////////////////////////////////////////////////////////////////
// PROYECTO FIN DE CARRERA															  											 	//
// TITULO: Disenyo de nuevas arquitecturas y algoritmos de gestin de recursos en	//
//		  	 redes de acceso FiWi  												  												//
// AUTOR: Ana Emma Lopez Mato																											//
// TUTOR: Noemi Merayo Alvarez																										//
// INGENIERIA TECNICA DE TELECOMUNICACIONES, SISTEMAS DE TELECOMUNICACION					//
// UNIVERSIDAD DE VALLADOLID													      											//
////////////////////////////////////////////////////////////////////////////////////

#ifndef __RED_WIRELESS_RXUSER_H_
#define __RED_WIRELESS_RXUSER_H_

#include <omnetpp.h>
#include "GATE_m.h"
#include "REPORT_m.h"
#include "ETHERNET_m.h"
/*
 * MODULO ONU_Rxuser:
 */
class ONU_Rxuser : public cSimpleModule
{
	private:
		cStdDev eedStats; // PARAMETRO DE ESTADISTICAS DEFINIDO PARA OBTENERLAS MANUALMENTE
		int nombreonu; // VARIABLE QUE INDICA EL IDENTIFICADOR DE LAS ONUS
		long numReceived; // VARIABLE PARA CONTAR EL NUMERO DE PAQUETES ETHERNET RECIBIDOS

	protected:
		virtual void initialize();
		virtual void handleMessage(cMessage *msg);

		virtual void finish();// DEFINICION DE LA FUNCION FINALIZAR
};

#endif
