////////////////////////////////////////////////////////////////////////////////////
// PROYECTO FIN DE CARRERA                                                                                                          //
// TITULO: Disenyo de nuevas arquitecturas y algoritmos de gesti���n de recursos en //
//           redes de acceso FiWi                                                                                               //
// AUTOR: Ana Emma Lopez Mato                                                                                                           //
// TUTOR: Noemi Merayo Alvarez                                                                                                      //
// INGENIERIA TECNICA DE TELECOMUNICACIONES, SISTEMAS DE TELECOMUNICACION                   //
// UNIVERSIDAD DE VALLADOLID                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////

#ifndef __RED_WIRELESS_WDMSPLITTER_H_
#define __RED_WIRELESS_WDMSPLITTER_H_

#include <omnetpp.h>
#include "GATE_m.h"
#include "REPORT_m.h"
#include "ETHERNET_m.h"
#include "MAC_ONU.h"


// MODIFICADO POR DAVID
#include <vector>
using namespace std;


/*
 * MODULO OLT_WDMSplitter:
 */


// MODIFICADO POR DAVID
typedef std::vector< double_vector_t > double_matrix_t; // MATRIZ DE TIPO DOUBLE


class OLT_WDMSplitter : public cSimpleModule
{
     protected:
        double received_messages;
        virtual void initialize();
        virtual void handleMessage(cMessage *msg);


     // MODIFICADO POR DAVID
     public:
        double_vector_t B_alloc_lambda; //VECTOR QUE GUARDA EL ANCHO DE BANDA
        double_vector_t B_alloc_por_onu; //VECTOR QUE GUARDA EL ANCHO DE BANDA


};

#endif
